#include<bits/stdc++.h>

#pragma GCC optimize ("Ofast")

using namespace std;

#define rep(i,a,b) for(ll i = a; i<b;i++)
#define sz(v) ll(v.size())
#define all(v) v.begin(),v.end()

typedef long long ll;
typedef long double ld;
typedef vector<ll> vl;
typedef pair<ll,ll> pll;

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    ll n;
    cin>>n;

    if(n==1){
        cout<<"YES"<<endl;
        return 0;
    }

    vector<unordered_set<ll>> e(n);
    rep(i,0,n-1){
        ll a,b; cin>>a>>b;
        e[a-1].insert(b-1);
        e[b-1].insert(a-1);
    }

    vl s(n,1);

    priority_queue<pll> q;
    rep(i,0,n) {
        if(e[i].size()==1) q.emplace(-s[i],i);
    }


    while(q.size()){
        ll ign,v;
        tie(ign,v) = q.top();
        // cout<<"v="<<v<<endl;
        q.pop();
        if(sz(e[v])){
            ll u = *e[v].begin();
            // cout<<s[v]<<" "<<s[u]<<endl;
            if(s[v]<=s[u]){
                // cout<<"y"<<v<<endl;
                e[v].erase(u);
                e[u].erase(v);
                s[u] += s[v];
                s[v] = 0;
                if(sz(e[u])==1) {
                    // cout<<"push"<<" "<<u<<endl;
                    q.emplace(-s[u],u);
                }


                // cout<<v<<" "<<u<<" "<<s[u]<<endl;

                if(s[u]==n){
                    cout<<"YES"<<endl;
                    return 0;
                }
            }
        }
    }

    cout<<"NO"<<endl;
}