#include<bits/stdc++.h>

#pragma GCC optimize ("Ofast")

using namespace std;

#define rep(i,a,b) for(ll i = a; i<b;i++)
#define sz(v) ll(v.size())
#define all(v) v.begin(),v.end()

typedef long long ll;
typedef long double ld;
typedef vector<ll> vl;
typedef pair<ll,ll> pll;

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    ll n;
    cin>>n;

    vector<string> s(n);
    rep(i,0,n) cin>>s[i];


    rep(mask,0,1<<(n-1)){
        vector<vl> parts(2);

        rep(i,0,n) parts[(mask>>i)&1].push_back(i);

        if(sz(parts[0])>sz(parts[1])) swap(parts[0],parts[1]);

        bool good = true;
        char bigpart = '.';

        rep(i,0,sz(parts[1]))
            rep(j,i+1,sz(parts[1])){
                char c = s[parts[1][i]][parts[1][j]];
                if(c!='?'){
                    if(bigpart=='.') bigpart=c;
                    if(bigpart != c) good = false;
                }
            }
        

        char crossing = '.';

        rep(i,0,sz(parts[0]))
            rep(j,0,sz(parts[1])){
                char c = s[parts[0][i]][parts[1][j]];
                if(c!='?'){
                    if(crossing=='.') crossing=c;
                    if(crossing != c) good = false;
                }
            }
        
        if(good && (crossing!=bigpart || (bigpart=='.')) && sz(parts[1])*8<=6*n && sz(parts[1])*8>=5*n){
            if(crossing=='.'){
                if(bigpart=='F') crossing='S';
                else crossing='F';
            }
            if(bigpart=='.'){
                if(crossing=='F') bigpart='S';
                else bigpart='F';
            }
            
            vector<string> ans(n,string(n,'.'));
            rep(i,0,sz(parts[0]))
                rep(j,0,sz(parts[1])){
                    ans[parts[0][i]][parts[1][j]] = crossing;
                    ans[parts[1][j]][parts[0][i]] = crossing;
                }
            rep(i,0,sz(parts[1]))
                rep(j,0,sz(parts[1]))
                    ans[parts[1][i]][parts[1][j]] = bigpart;
            rep(i,0,sz(parts[0]))
                rep(j,0,sz(parts[0])){
                    if(s[parts[0][i]][parts[0][j]]!='?'){
                        ans[parts[0][i]][parts[0][j]] = s[parts[0][i]][parts[0][j]];
                    } else {
                        ans[parts[0][i]][parts[0][j]] = 'F';
                    }
                }

            rep(i,0,n) cout<<ans[i]<<"\n";
            return 0;
        }
    }
}