#include<bits/stdc++.h>

#pragma GCC optimize ("Ofast")

using namespace std;

#define rep(i,a,b) for(ll i = a; i<b;i++)
#define sz(v) ll(v.size())
#define all(v) v.begin(),v.end()

typedef long long ll;
typedef __int128_t lll;
typedef long double ld;
typedef vector<ll> vl;
typedef pair<ll,ll> pll;

vector<vector<ll>> adj;
vector<ll> vis;
ll c0 = 0;
ll c1 = 0;
bool poss = true;

void dfs(ll curr, ll col)
{
    if (vis[curr] != -1)
    {
        if (vis[curr] != col) poss = false;
        return;
    }

    vis[curr] = col;
    if (col == 0) c0++;
    else c1++;

    for (auto j : adj[curr]) dfs(j, 1 - col);
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    ll n;
    cin >> n;

    vector<pair<ll, ll>> c(n);
    vector<ll> r(n);

    for (ll i = 0; i < n; i++) cin >> c[i].first >> c[i].second >> r[i];

    adj.resize(n);

    for (ll i = 0; i < n; i++)
    {
        for (ll j = 0; j < i; j++)
        {
            lll dx = c[i].first - c[j].first;
            lll dy = c[i].second - c[j].second;
            lll sd = dx*dx + dy*dy;

            lll rd = r[i] + r[j];

            if (rd*rd == sd)
            {
                adj[i].push_back(j);
                adj[j].push_back(i);
            }
        }
    }

    vis.assign(n, -1);

    for (ll i = 0; i < n; i++)
    {
        if (vis[i] != -1) continue;
        c0 = 0;
        c1 = 0;
        poss = true;
        dfs(i, 0);

        if (poss)
        {
            if (c0 != c1)
            {
                cout << "YES\n";
                return 0;
            }
        }
    }
    cout << "NO\n";
}